﻿/* 
_________________________________________________________

S I M P L E   R S S   F E E D   R E A D E R
Ron Kessler
Created 1/2/2017

C# Version

This demo shows how to get RSS feeds and display
in a WebBrowser Control in a Standard Desktop app. 

Add a panel control and dock it to the top of your form.
Add the buttons/controls you see and name them.

Add a Webbrowser control from the toolbox and dock it to the form
using the fill enumeration in the dock property.

I have it start on the CNN rss feed by default but you can copy in
any URL and click GO to take you there.
_________________________________________________________ 

Updated 1/3/2017 to suppress JS error messages
 */

using System;
using System.Windows.Forms;

//---add these. Also add a new Reference for System.ServiceModel
using System.ServiceModel.Syndication;
using System.Xml;

namespace RSS_Demo_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.CenterToScreen();
        }

        private string url { get; set; }    //property holds our URL

        private void Form1_Load(object sender, EventArgs e)
        {
            //---to get started
            url = "http://rss.cnn.com/rss/cnn_tech.rss";
            GetRSSFeed(url);
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            //---is there any browser history?
            if (webBrowser1.CanGoBack)
                webBrowser1.GoBack();
        }

        private void btnForward_Click(object sender, EventArgs e)
        {
            if (webBrowser1.CanGoForward)
                webBrowser1.GoForward();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            //---make sure they type in something!
            if (txtURL.Text.Trim().Length > 0)
                GetRSSFeed(url);
           
        }

        private void GetRSSFeed(string whichURL)
        {

           //---make it so! We use an XML reader similar to a StreamReader
            XmlReader reader = XmlReader.Create(url);
            SyndicationFeed myFeed = SyndicationFeed.Load(reader);
            reader.Close();

            webBrowser1.ScriptErrorsSuppressed = true;  //no JS error boxes
            webBrowser1.Navigate(url);      //now show it

        }
    }
}
